import java.io.*;

public class Interviewer extends Object {

    private int maxLength, charEnd;
    public Interviewer (int maxL) {
        maxLength = maxL;
        charEnd = maxLength + 2; // aus programmiertechnischen Gruenden
    }

    public String getText ()
        throws IOException {

        char[] c = new char[charEnd];
        int length = 0;

        InputStreamReader inR = new InputStreamReader (System.in);
        length = inR.read (c,0,charEnd);             // IOException wird weitergeleitet

        if (length-1 > maxLength)                    // (ENTER) gilt als Zeichen
            throw new IOException ("Text too long.");
        char [] cc = new char[length-1];
        for (int i = 0; i < length-1; i++) cc[i] = c[i];  // garrantiert das Rueckgabe-
        return new String (cc);                           // String nur so lang wie Eingabe
    }

    public boolean getAnswer ()
        throws IOException {
        boolean answer = false;

        System.out.println ("Bitte antworten Sie mit \"J\" oder \"N\" (ENTER):");
        String c = getText();                             // IOException wird weitergeleitet

        if (!(c.equalsIgnoreCase ("j") || c.equalsIgnoreCase ("n")))
              throw new IOException ("Antwort war nicht \"J\" oder \"N\".");
        if (c.equalsIgnoreCase ("j")) answer = true;
        if (c.equalsIgnoreCase ("n")) answer = false;

        return answer;
    }

}
