public class ArrayContainer
       implements  BoundedContainer
{
  protected  Object  array[];
  protected  int     currentIndex;

  public  ArrayContainer( int size )  {
    array = new Object[ size ];
    currentIndex = 0;
  }
  
  public  int  getMaxCapacity()  {  
    return  array.length;
  }
  
  public  int  getNumberOfElements()  {
    return  currentIndex;
  }

  public  void addElement( Object object )  {
    if (currentIndex >= array.length)
      throw new TooManyElementsException();

    array[ currentIndex++ ] = object;
  }
  
  public  Iterator  getElements()  {
    return  new  ArrayIterator();
  }

  
  
  protected  class  ArrayIterator  
           implements  Iterator
  {
    protected  int  currentIndex = 0;

    public  Object  getNextElement()  {
      if (currentIndex >= array.length)
        throw new NoNextElementException();
      
      return  array[currentIndex++];
    }

    public  boolean hasNextElement()  {
      return  currentIndex < array.length;
    }
  }

}