/*  
    Euklid.java
 
    euklid's gcd algorithm

    - do not distribute - colonelcrusher@gmx.net
  
    todo: -

    01.11.99: tk, using repeated subtraction method.
    27.10.99: tk, dc, x/y calculation added.
    26.10.99: tk, implementation changed to use BigIntegers.
    25.10.99: tk, initial version.

    Copyright (c)1999 by Thomas Kindler aka cc/kreaPC.
    All rights reserved.
 
    This software may be freely copied, modified and redistributed without
    fee for non-commerical purposes provided that this copyright notice is
    preserved intact on all copies and modified copies.
 
    There is no warranty or other guarantee of fitness of this software.
    It is provided solely "as is". The author(s) disclaim(s) all
    responsibility and liability with respect to this software's usage
    or its effect upon hardware or computer systems.
*/

import java.math.*;

public class Euklid  {
  
  static BigInteger gcd( BigInteger a, BigInteger b ) {
    
    while ( (a.compareTo(BigInteger.ZERO)>0) && 
            (b.compareTo(BigInteger.ZERO)>0) ) {
      
      if (a.compareTo(b) > 0)
        a = a.subtract(b);
      else  
        b = b.subtract(a);
      
      System.out.println("a="+a+" b="+b);
    
    }
              
    return (a.compareTo(b)>0) ? a : b;
  }

  static void main( String[] args )  {
    BigInteger a, b, c;
    
    a = new BigInteger("6464");
    b = new BigInteger("31232");
 
    System.out.println( "euklid's gcd algorithm" );        
    
    c = gcd(a,b);
 
    System.out.println( "  gcd(a,b) = " + c  );
    System.out.println( "  lcm(a,b) = " + a.multiply(b).divide(c) );
  }

}