/*  
    Euklid.java
 
    euklid's gcd algorithm

    - do not distribute - colonelcrusher@gmx.net
  
    todo: -

    26.10.99: tk, implementation changed to use BigIntegers
    25.10.99: tk, initial version.

    Copyright (c)1999 by Thomas Kindler aka cc/kreaPC.
    All rights reserved.
 
    This software may be freely copied, modified and redistributed without
    fee for non-commerical purposes provided that this copyright notice is
    preserved intact on all copies and modified copies.
 
    There is no warranty or other guarantee of fitness of this software.
    It is provided solely "as is". The author(s) disclaim(s) all
    responsibility and liability with respect to this software's usage
    or its effect upon hardware or computer systems.
*/

import java.math.*;

public class BigEuklid  {
  
  static BigInteger gcd( BigInteger a, BigInteger b ) {
    
    while (!b.equals(BigInteger.ZERO))  {
      BigInteger q = a.divide(b);        // unnecessary for gcd calculation
      BigInteger r = a.remainder(b);

      System.out.println( "a="+a+", b="+b+", q="+q+", r="+r );
      
      a = b;  b = r;
    }
                
    return a;
  }

  static void main( String[] args )  {
    BigInteger a, b, c;
    
    a = new BigInteger("28374783452476523757523754785733545");
    b = new BigInteger("1243676512457134514561451241245124765245");
 
    System.out.println( "euklid's gcd algorithm" );        
    
    c = gcd(a,b);
 
    System.out.println( "  gcd(a,b) = " + c  );
    System.out.println( "  lcm(a,b) = " + a.multiply(b).divide(c) );
  }

}