/*
    Hanoi.java
    gvpr ws99/2ooo, bungsblatt 7

    Copyright (C) 1999  Thomas Kindler (tk)
    e-mail: thomas.kindler@gmx.de

    todo: -

    25.11.99: tk, initial version.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


class Hanoi  {
   
  // Array, das zu jeder Scheibengre den jeweiligen
  // Pmpel speichert (genau andersherum als in der
  // Aufgabenstellung vorgeschlagen!). Um die Methoden
  // mglichst bersichtlich zu halten, wird element 0 
  // nicht benutzt.
  //
  private int scheiben[];

  
  // Konstruktor, der als Parameter die Anzahl der
  // Scheiben erwartet. Danach werden alle Scheiben
  // auf Turm 1 gepackt.
  //
  public Hanoi( int n )  {
    scheiben = new int[n+1];
    
    for (int i=1; i<=n; i++)
      scheiben[i] = 1;
  }
        

  // Verschiebt (rekursiv) einen Turm von Scheiben,
  // beginnend mit der Gre n um einen Plppel nach 
  // links (richtung<0) oder rechts (>0). Um den kompletten
  // Turm um eins nach rechts zu verschieben, werden zuerst 
  // (rekursiv) n-1 Scheiben nach links verschoben, danach 
  // die Scheibe n nach rechts, schlielich werden die 
  // anderen Scheiben wieder draufgelegt.
  // 
  public void VerschiebeRekursiv( int n, int richtung )  {
    
    if (n == 0)
      return;

    VerschiebeRekursiv( n-1, -richtung );
    Verschiebe( n, richtung );
    VerschiebeRekursiv( n-1, -richtung );    
  }

  
  // Verschiebt eine einzelne Scheibe mit Radius n
  // nach links oder rechts. Wenn eine Scheibe von
  // Plppel eins nach links geschoben wird, landet
  // sie dabei auf nummer 3 (und umgekehrt..)
  //
  private void Verschiebe( int n, int richtung ) {
    System.out.println( "Scheibe #" + n + " nach "
                        + (richtung > 0 ? "rechts" : "links")
                        + " verschieben." );                
    
    scheiben[n] += richtung;
    if (scheiben[n] < 1) scheiben[n] = 3;
    if (scheiben[n] > 3) scheiben[n] = 1;
    
    System.out.println( this );
  }


  public String toString()  {    
    
    String s = "";
    
    for (int t=1; t<=3; t++) {
      s += "Turm #" + t + ": ";      
     
      for (int n = scheiben.length-1; n > 0; n--)
        if (scheiben[n] == t)
          s += n + " ";
     
      s += "\n";
    }
    
    return s; 
  }

  
  public static void main( String argv[] ) {
    Hanoi hanoi = new Hanoi(4);
    
    System.out.println( "Die Trme von Hanoi" );
    System.out.println( hanoi );
    hanoi.VerschiebeRekursiv( 4, 1 );
  }
  
  /* Ausgabe: Achtung! Aus platzgrnden habe ich die Ausgabe
              fr _DREI_ Scheiben angegeben. Fr 4 Scheiben
              wird natrlich auch ein richtiges Ergebnis 
              geliefert.
 
    Die Trme von Hanoi
    Turm #1: 3 2 1 
    Turm #2: 
    Turm #3: 
    
    Scheibe #1 nach rechts verschieben.
    Turm #1: 3 2 
    Turm #2: 1 
    Turm #3: 
    
    Scheibe #2 nach links verschieben.
    Turm #1: 3 
    Turm #2: 1 
    Turm #3: 2 
    
    Scheibe #1 nach rechts verschieben.
    Turm #1: 3 
    Turm #2: 
    Turm #3: 2 1 
    
    Scheibe #3 nach rechts verschieben.
    Turm #1: 
    Turm #2: 3 
    Turm #3: 2 1 
    
    Scheibe #1 nach rechts verschieben.
    Turm #1: 1 
    Turm #2: 3 
    Turm #3: 2 
    
    Scheibe #2 nach links verschieben.
    Turm #1: 1 
    Turm #2: 3 2 
    Turm #3: 
    
    Scheibe #1 nach rechts verschieben.
    Turm #1: 
    Turm #2: 3 2 1 
    Turm #3:

  */
}