class Point2D {
  int x, y;
  
  Point2D(int x, int y) {
    this.x = x;
    this.y = y;
  }

  public boolean equals(Point2D dd) {
    return ((this.x == dd.x) && (this.y == dd.y));
  }
  
  public String toString() {
    return ("("+x+","+y+")");
  }
}

class Point3D extends Point2D {
  int z;
  
  Point3D(int x, int y, int z) {
    super(x,y);
    this.z = z;
  }
  
  public boolean equals(Point3D ddd) {
    return (super.equals(ddd) && (this.z == ddd.z));
  }
  
  public String toString() {
    return ("("+x+","+y+","+z+")");
  }
}

public class PointTest {

  public static void compare(Point2D dd1, Point2D dd2) {
    System.out.println(dd1+ "="+dd2 + ": " +dd1.equals(dd2)+"\n");
  }

  static void main(String args[]) {
    Point2D dd1 = new Point2D(3,5);
    Point2D dd2 = new Point2D(3,9);
    Point3D ddd1 = new Point3D(3,5,7);
    Point3D ddd2 = new Point3D(3,5,9);
    // Teil a:
    compare(dd1, dd1);
    compare(dd1, dd2);
    // Teil b:
    compare(dd2, ddd1);
    compare(dd1, ddd1);
    // Teil c:
    compare(ddd1, ddd2);
    System.out.println(ddd1 + "=" +ddd2 +": " +ddd1.equals(ddd2)+"\n");
  }
}


/* Ausgabe:
    (3,5)=(3,5): true         klar.
    (3,5)=(3,9): false        auch klar.
    (3,9)=(3,5,7): false      stimmt schon.

    (3,5)=(3,5,7): true
      In Diesem Fall wird die equals() Methode aus der 
      Point2D Klasse aufgerufen. Diese checkt aber nur die 
      x und y Koordinate. Daher liefert Compare() true, 
      obwohl die Punkte offensichtlich nicht gleich sind.

    (3,5,7)=(3,5,9): true     soso... ok.
    (3,5,7)=(3,5,9): false    wieso auch nicht?
*/