
interface Vergleichbar  {

  boolean Gleich( Vergleichbar val );
  boolean Groesser( Vergleichbar val );
  boolean Kleiner( Vergleichbar val );
}


class Zahl implements Vergleichbar  {

  private  int  n;
  
  public Zahl( int wert )  {    
    n = wert;
  }

  public boolean Gleich( Vergleichbar val )  {
    return  (n == ((Zahl)val).n );
  }
  
  public boolean Groesser( Vergleichbar val )  {
    return  (n > ((Zahl)val).n );    
  }
    
  public boolean Kleiner( Vergleichbar val )  {
    return  (n < ((Zahl)val).n );    
  }
}


class Zeichen implements Vergleichbar  {
  
  private  char  c;

  public Zeichen( char zeichen )  {
    c = zeichen;
  }

  public boolean Gleich( Vergleichbar val )  {
    return  (c == ((Zeichen)val).c );
  }
  
  public boolean Groesser( Vergleichbar val )  {
    return  (c > ((Zeichen)val).c );    
  }
    
  public boolean Kleiner( Vergleichbar val )  {
    return  (c < ((Zeichen)val).c );    
  }
}



class Test  {
    
  public static void TestMethode( Vergleichbar v1, 
                                  Vergleichbar v2 )  {
                               
    System.out.println( "  v1 = v2 " + v1.Gleich(v2) );  
    System.out.println( "  v1 > v2 " + v1.Groesser(v2) );
    System.out.println( "  v1 < v2 " + v1.Kleiner(v2) );
  }
  
  
  public static void main( String argv[] )  {
  
    Zahl     a = new Zahl( 5);
    Zahl     b = new Zahl(10);

    Zeichen  x = new Zeichen( 'X' );
    Zeichen  y = new Zeichen( 'Y' );

    System.out.println( "v1 = 5, v2 = 10" );
    TestMethode( a, b );
    
    System.out.println( "\nv1 = 'X', v2 = 'Y'" );
    TestMethode( x, y );
      
    System.out.println( "\nv1 = '5', v2 = 'X'" );
    TestMethode( a, x );
 

    /*  Ausgabe:
     
      v1 = 5, v2 = 10
        v1 = v2 false
        v1 > v2 false
        v1 < v2 true
      
      v1 = 'X', v2 = 'Y'
        v1 = v2 false
        v1 > v2 false
        v1 < v2 true
      
      v1 = '5', v2 = 'X'
      java.lang.ClassCastException: Zeichen
        at Zahl.Gleich(Interface.java:19)
        at Test.TestMethode(Interface.java:61)
        at Test.main(Interface.java:81)
    
    */

  }
}